package ga.chromosomes;

@SuppressWarnings("serial")
public class ByteChromosome extends Chromosome {
    protected byte alleles[];

    public ByteChromosome(int allelesPerChromosome) {
        this(new byte[allelesPerChromosome]);
        for (int i = 0; i < allelesPerChromosome; i++) {
            if (random.nextDouble() > 0.5) 
                alleles[i] = 1;
            else
                alleles[i] = 0;
        }
    }

    public ByteChromosome(byte[] alleles){
        this.alleles = alleles;
    }

    public void setAllele(int index, byte value) {
        alleles[index] = value;
    }

    public byte getAllele(int index) {
        return alleles[index];
    }

    public int getLength() {
        return alleles.length;
    }

    public Chromosome deepCopy() {
        byte[] allelesCopy = this.alleles.clone();
        ByteChromosome result = new ByteChromosome(allelesCopy);
        return result;
    }

    public void partiallyCopyFromOtherChromosome(Chromosome other, int crossoverStart, int crossoverEnd) {
        for (int i = crossoverStart; i <= crossoverEnd; i++) {
            setAllele(i, ((ByteChromosome)other).getAllele(i));
        }
    }
    
    public void print() {
        for (int i = 0; i < alleles.length; i++)
            System.out.print(alleles[i]);
        System.out.print('\n');
    }
}
