package ga.chromosomes;

@SuppressWarnings("serial")
public class IntChromosome extends Chromosome {
    private int[] alleles;

    public IntChromosome(int allelesPerChromosome) {
        this(allelesPerChromosome, Integer.MAX_VALUE);
    }

    public IntChromosome(int allelesPerChromosome, int maxValue) {
        this(new int[allelesPerChromosome]);
        for (int i = 0; i < allelesPerChromosome; i++) {
            alleles[i] = (int) (random.nextDouble() * maxValue);
        }
    }

    public IntChromosome(int[] alleles) {
        this.alleles = alleles;
    }

    public void setAllele(int index, int value) {
        alleles[index] = value;
    }

    public int getAllele(int index) {
        return alleles[index];
    }

    public int getAlleleIndexByValue(int value) {
        for (int i = 0; i < alleles.length; i++) {
            if (alleles[i] == value) {
                return i;
            }
        }
        return -1;
    }

    public int getLength() {
        return alleles.length;
    }

    public Chromosome deepCopy() {
        IntChromosome result = new IntChromosome(this.alleles.clone());
        return result;
    }

    public void partiallyCopyFromOtherChromosome(Chromosome other, int crossoverStart,
            int crossoverEnd) {
        for (int i = crossoverStart; i <= crossoverEnd; i++) {
            setAllele(i, ((IntChromosome) other).getAllele(i));
        }
    }

    public void print() {
        for (int i = 0; i < alleles.length; i++)
            System.out.printf("Allele %d: %d\n", i, alleles[i]);
    }
}
