package ga.problems;

import ga.Individual;
import ga.chromosomes.ByteChromosome;
import ga.problems.helpers.BasicChromosomeStrategy;

public class ProblemOneMax extends Problem {
    public ProblemOneMax(int allelesPerChromosome, double crossoverProbability,
            double mutationsPerChromosome) {
        super(allelesPerChromosome);
        chromosomeStrategy = new BasicChromosomeStrategy(
            allelesPerChromosome,
            crossoverProbability,
            mutationsPerChromosome,
            this);
    }

    public double evaluate(Individual individual) {
        double score = 0.0;
        for (int i = 0; i < allelesPerChromosome; i++) {
            if (((ByteChromosome) (individual.getChromosome())).getAllele(i) == 1) {
                score = score + 1.0;
            }
        }
        individual.setScore(score);
        return score;
    }
}
