package ga.problems.helpers;

/**
 * keeps a list of integers such that they can be "crossed off" and the
 * remaining ones returned efficiently. Requires that the integers are a
 * continuous series from 0...N
 * 
 * implemented as a simple list of boolean values, indicating 'true' for 'used'
 * and 'false' for 'unused'
 */
public class IntegerChecklist {
    private boolean[] list;
    private int numberRemaining;

    public IntegerChecklist(int length) {
        list = new boolean[length];
        for (int i = 0; i < length; i++) {
            list[i] = false;
        }
        numberRemaining = length;
    }

    /**
     * Returns false if the number was already checked off, true if it was not.
     */
    public boolean checkOff(int i) {
        boolean result = false;
        if (!list[i]) {
            numberRemaining--;
            result = true;
        }
        list[i] = true;
        return result;
    }

    public boolean isCheckedOff(int i) {
        return list[i];
    }

    public int[] getValuesNotYetCheckedOff() {
        int[] result = new int[numberRemaining];
        int currentResultIndex = 0;
        for (int i = 0; i < list.length; i++) {
            if (!list[i]) {
                result[currentResultIndex++] = i;
            }
        }
        return result;
    }
}
