package ga.problems.helpers;

import java.util.Random;

public class RandomIntSequence {
    int[] sequence;
    int numbersRemaining;
    Random random = new Random();

    public RandomIntSequence(int[] sequence) {
        this.sequence = sequence;
        numbersRemaining = sequence.length;
    }

    public RandomIntSequence(int length) {
        this(length, 0);
    }

    public RandomIntSequence(int length, int startValue) {
        sequence = new int[length];
        for (int i = 0; i < length; i++) {
            sequence[i] = i + startValue;
        }
        numbersRemaining = sequence.length;
    }

    public int getNext()  {
        if (numbersRemaining == 0) {
            throw new ArrayIndexOutOfBoundsException();
        }
        int i = random.nextInt(numbersRemaining);
        int result = sequence[i];
        sequence[i] = sequence[--numbersRemaining];
        return result;
    }
}
